<?php 
namespace Concrete\Package\AdvancedColorPicker;

use Concrete\Core\Editor\Plugin;
use \Core;
use \AssetList;

class Controller extends \Concrete\Core\Package\Package
{

    protected $pkgHandle = 'advanced_color_picker';
    protected $appVersionRequired = '5.7.5';
    protected $pkgVersion = '1.0c';

    public function getPackageDescription()
    {
        return t("Set the foreground and background color of text.");
    }

    public function getPackageName()
    {
        return t("Advanced Color Picker");
    }

    public function on_start()
    {
        $al = AssetList::getInstance();
        $al->register(
            'javascript', 'editor/plugin/advanced_color_picker', 'js/redactor/advanced_color_picker.js',
            array(), 'advanced_color_picker'
            );

        $al->registerGroup('editor/plugin/advanced_color_picker', array(
            array('javascript', 'editor/plugin/advanced_color_picker'),
            ));

        $plugin = new Plugin();
        $plugin->setKey('advanced_color_picker');
        $plugin->setName(t('Advanced Color Picker'));
        $plugin->requireAsset('editor/plugin/advanced_color_picker');

        Core::make('editor')->getPluginManager()->register($plugin);
    }
    
    public function install() {
        $pkg = parent::install();
        $r = \Request::getInstance();
        $editor = \Core::make('editor');
        $manager = \Core::make("editor")->getPluginManager();
        $pluginsObject = $manager->getAvailablePlugins();
        foreach ($pluginsObject AS $key => $value) {
            if ($manager->isSelected($key) == 1) {
                $plugins[] = $key;
            }
        }
        if ($r->request->get('install_color_picker') && $r->request->get('install_color_picker') == 1) {
            $plugins[] = "advanced_color_picker";
            \Config::save('concrete.editor.plugins.selected', $plugins);
        }
    }
}