(function($)
{
	$.Redactor.prototype.advanced_color_picker = function() {
		return {
			getTemplate: function() {
				return String()
				+ '<section id="redactor-modal-advanced">'
				+ '<br><div id="redactor-example" style="color: #FF0000; padding: 10px; margin: 0 auto;">Example Text</div><br><br>'
				+ '<label style="width: 150px;">Foreground Color : </label>'
				+ '<input type="text" id="acp-foreground" value="#ff0000"><br><br>'
				+ '<label style="width: 150px;">Background Color : </label>'
				+ '<input type="text" id="acp-background" value="transparent">'
				+ '</section>'
			},
			init: function () {
				var button = this.button.add('advanced', 'Advanced Color Picker');
				this.button.addCallback(button, this.advanced_color_picker.show);

				this.button.setAwesome('advanced', 'fa-eyedropper');
			},
			show: function() {
				this.modal.addTemplate('advanced', this.advanced_color_picker.getTemplate());
				this.modal.load('advanced', 'Advanced Color Picker', 400);
				this.modal.createCancelButton();

				var button = this.modal.createActionButton('Set Text Color');
				button.on('click', this.advanced_color_picker.insert);

				var resetButton = this.modal.createActionButton('Remove Styles');
				resetButton.on('click', this.advanced_color_picker.reset);

				ccm_addHeaderItem(CCM_REL + "/concrete/css/spectrum.css", "CSS");
				ccm_addHeaderItem(CCM_REL + "/concrete/js/spectrum.js", "JAVASCRIPT");

				$('#acp-foreground').spectrum({
					color: '#ff0000',
					className: 'ccm-widget-colorpicker',
					showInitial: true,
					showInput: true,
					change: function(color) {
						color = color.toHexString();
						$('#redactor-example').css('color', color);
					},
					allowEmpty: true,
					cancelText: 'Cancel',
					chooseText: 'Choose',
					showAlpha: true,
					clearText: 'Clear Color Selection',
				});
				$('#acp-background').spectrum({
					color: 'transparent',
					className: 'ccm-widget-colorpicker',
					showInitial: true,
					showInput: true,
					change: function(color) {
						color = color.toHexString();
						$('#redactor-example').css('background-color', color);
					},
					allowEmpty: true,
					cancelText: 'Cancel',
					chooseText: 'Choose',
					showAlpha: true,
					clearText: 'Clear Color Selection',
				});
				this.selection.save();
				this.modal.show();
			},
			insert: function() {
				var color = $('#acp-foreground').val();
				var background = $('#acp-background').val();
				this.selection.restore();
				this.inline.format('span', 'style', 'color: ' + color +';');
				this.inline.format('span', 'style', 'background-color: ' + background +';');
				this.code.sync();
				this.modal.close();
			},
			reset: function() {
				this.inline.removeFormat();
			}
		};
	};
})(jQuery);